/* Most of everything used to define the timers */

typedef struct {
  GtkWidget* one;
  GtkWidget* two;
  GtkWidget* box;
} widget_pair;

#define TIMER_PAIR widget_pair

#define new_timer2(timer) \
        gtk_progress_bar_new(); \
	gtk_progress_set_show_text(GTK_PROGRESS(timer), TRUE)

#define reset_timer2(timer) gtk_progress_set_value(GTK_PROGRESS(timer), 0)

#define update_timer2(timer,current_value) \
        if (total_time != 0) \
           gtk_progress_set_value(GTK_PROGRESS(timer), current_value)

#define BOX(timer) timer.box

#if TIMER == LABEL
#define new_timer(timer) \
        timer.one = gtk_label_new("0:00/-:--"); \
        timer.two = new_timer2(timer.two); \
        timer.box = gtk_hbox_new(FALSE, 0); \
        gtk_box_pack_end(GTK_BOX(timer.box), timer.two, TRUE, TRUE, 0); \
        gtk_box_pack_start(GTK_BOX(timer.box), timer.one, FALSE, FALSE, 4); \
        gtk_widget_show(timer.one); \
        gtk_widget_show(timer.two)
#define reset_timer(timer) \
       if (total_time == 0) \
          strcpy(tempstr, "0:00/-:--"); \
       else \
          snprintf(tempstr, MAX_STRING_SIZE, "0:00/%d:%02d", total_time / 60, total_time % 60); \
       gtk_label_set_text(GTK_LABEL(timer.one), tempstr); \
       reset_timer2(timer.two)
#define update_timer(timer,current_value) \
       gdk_threads_enter(); \
       if (total_time == 0) \
          snprintf(tempstr, MAX_STRING_SIZE, "%d:%02d/-:--", current_value / 60, current_value % 60); \
       else \
          snprintf(tempstr, MAX_STRING_SIZE, "%d:%02d/%d:%02d", current_value / 60, current_value % 60, total_time / 60, total_time % 60); \
       gtk_label_set_text(GTK_LABEL(timer.one), tempstr); \
       update_timer2(timer.two,current_value); \
       gdk_threads_leave()
#elif TIMER == TEXT
#define new_timer(timer) \
       timer.one = gtk_entry_new(); \
       gtk_entry_set_text(GTK_ENTRY(timer.one), "0:00/-:--"); \
       gtk_editable_set_editable(GTK_EDITABLE(timer.one), FALSE); \
       timer.two = new_timer2(timer.two); \
       timer.box = gtk_hbox_new(FALSE, 0); \
       gtk_box_pack_end(GTK_BOX(timer.box), timer.two, TRUE, TRUE, 0); \
       gtk_box_pack_start(GTK_BOX(timer.box), timer.one, FALSE, FALSE, 0); \
       gtk_widget_show(timer.one); \
       gtk_widget_show(timer.two)
#define reset_timer(timer) \
       if (total_time == 0) \
          strcpy(tempstr, "0:00/-:--"); \
       else \
          snprintf(tempstr, MAX_STRING_SIZE, "0:00/%d:%02d", total_time / 60, total_time % 60); \
       gtk_entry_set_text(GTK_ENTRY(timer.one), tempstr); \
       reset_timer2(timer.two)
#define update_timer(timer,current_value) \
       gdk_threads_enter(); \
       if (total_time == 0) \
          snprintf(tempstr, MAX_STRING_SIZE, "%d:%02d/-:--", current_value / 60, current_value % 60); \
       else \
          snprintf(tempstr, MAX_STRING_SIZE, "%d:%02d/%d:%02d", current_value / 60, current_value % 60, total_time / 60, total_time % 60); \
       gtk_entry_set_text(GTK_ENTRY(timer.one), tempstr); \
       update_timer2(timer.two,current_value); \
       gdk_threads_leave()
#endif

#define define_timer(timer,min,maxx) \
       if (maxx == 0) \
          gtk_progress_configure(GTK_PROGRESS(timer.two), 0, 0, 1); \
       else \
          gtk_progress_configure(GTK_PROGRESS(timer.two), 0, min, maxx); \
       reset_timer(timer)
